/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : profe_wb.c
Last edit : 10/20/92
Created   :
Version   : 1.3

History   :

Does      : The work-horse of profession choosing.
*/

#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <curses.h>
#include <paths.h>
#include <limits.h>

#include "profe_mai.h"

extern char 	*get_word(FILE *src);
extern void 	siemen(void);
extern int 	sattuma(int,int);
extern char	*mstrtok(char *, char *);

void do_profe(char *arg)
{
  FILE 			*src=NULL;
  FILE 			*dst=NULL;
  char 			*t=NULL;
  int 			lkm=0;
  struct profe_mai 	*profs=NULL;
  int 			i=0;
  int 			ok=0;
  int 			m=0;
  char 			*directory=NULL;
  int 			len = 0;
  char 			*dirri=NULL;
  char 			*name=NULL;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    fprintf(stderr,"profe_wb.c/mrstrtok()");
    exit(0);
  }

  len = strlen(directory) + strlen(SAVE) + 2;
  dirri = malloc(len);
  if(!dirri) {
    perror("profe_wb.c/do_profe()");
    exit(0);
  }
  
  len = strlen(directory) + 14 + 5;
  name = (char *)malloc(len);
  if(!name) {
    perror("profe_wb.c/do_profe()");
    exit(0);
  }

  sprintf(name,"%s.profe",directory);
  sprintf(dirri,"%s/%s",SAVE,directory);    

  if(chdir(dirri)) 
    if(mkdir(dirri,0755)) {
      printf("Unable to make directory\n");
      exit(0);
    } else 
      chdir(dirri);

  siemen();
  src = fopen(PROFES,"r");
  if(!src) {
    perror(PROFES);
    exit(0);
  }
  t = get_word(src);
  if(!t) 
    return;

  lkm = atoi(t);
  profs = (struct profe_mai *)calloc(lkm,sizeof(struct profe_mai));
  if(!profs) {
    perror("profe_wb/do_profe\n");
    exit(0);
  }

  for(i=0; i < lkm; i++) {
    move(21,1);
    printw("Reading profession data: %3i (%3i)", i+1,lkm);
    refresh();
    if(get_profe(&profs[i],src)) break;
    profs[i].nro = i;	
  }   
  fclose(src);

  clear();
  i = 0;
  refresh();
  ok =0;
  while(!ok) {
    put_profe_mai(&profs[i]);
    m = getch();
    m = isupper(m) ? tolower(m) : m;
    switch(m) {
      case 'x':			/* Exit. */
	ok = 1;
	break;
      case 'n':			/* Next. */
	i++;
	if(i == lkm)
	  i = 0;
	break;
      case 'p':			/* Previous. */
	i--;
	if(i == -1)
	  i = lkm-1;
	break;
      case 'l':			/* Goto letter. */
	move(14,44);
	printw("Letter?");
	refresh();
	while(1) {
	  m = getch();
	  m = islower(m) ? toupper(m) : m;
	  if( m >= 'A' && m <= 'Z')
	    break;
	}
	move(14,44);
	clrtoeol();
	refresh();
	while(m > profs[i++].profession[0] && i < lkm);
 	if(i >=lkm) i = lkm -1;
	while(m < profs[i--].profession[0] && i > -1);		
	if(i <=-1) i = 0;
	break;
      case 'r':				/* Random. */
	i = sattuma(0,lkm-1);
	break;	
      case 'a':				/* Accept. */
	dst = fopen(name,"w");
	if(!dst) {
	  move(14,44);
	  printw("Sorry, couldn't open");
	  move(15,44);
	  printw("save file.");
	  move(16,44);
	  printw("Press a key.");
	  refresh();
	  getch();
        }
        else {
	  fwrite(&profs[i],sizeof(struct profe_mai),1,dst); 	
	  fclose(dst);
	  move(14,44);
	  printw("Profession saved");
	  move(15,44);
	  printw("and accepted.");
	  move(16,44);
	  printw("Press a key.");
	  getch();
        }
	move(14,44);
	clrtoeol();
	move(15,44);
	clrtoeol();
	move(16,44);
	clrtoeol();
	refresh();
    }
  }
} 

/* Fetches profession data. */
int get_profe(struct profe_mai *m, FILE *src)
{
  char *t=NULL;
 
  if(!(t = get_word(src))) return -1;
  sprintf(m->profession,"%-24s",t);

  m->prime[0] = '\0';
  if(!(t = get_word(src))) return -1;
  sprintf(m->prime,"%2s/",t);

  if(!(t = get_word(src))) return -1;
  strcat(m->prime,t);
  strcat(m->prime,"/");

  if(!(t = get_word(src))) return -1;
  strcat(m->prime,t);


  if(!(t = get_word(src))) return -1;
  m->acd = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->arm = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->ath = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->bas = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->bod = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->con = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->dea = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->dir = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->gen = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->lin = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->mag = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->med = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->out = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->per = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->soc = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->sub = atoi(t);

  if(!(t = get_word(src))) return -1;
  if(!strcmp(t,"hybr"))
    sprintf(m->type,"hybrid");
  else
    sprintf(m->type,"%s",t);

  if(!(t = get_word(src))) return -1;
  sprintf(m->realm,"%s",t);

  return 0;
}

